//+------------------------------------------------------------------+
//|                                                    Pj-Doji's.mq4 |
//|                                      Copyright  2008, primajaya |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, primajaya"
#property link      ""
 
extern int TP=15;
extern int SL=30;
extern double Lot=0.1;

#define slip 2

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
    GlobalVariablesDeleteAll();
//----
   return(0);
  }

void openorder(string simbol, int trade, double lotsize, double price, double sl, double tp,string pesan, int magic) 
{  int tiket;                   
   tiket=OrderSend(simbol,trade,lotsize,price,slip,sl,tp,pesan,magic,0,White);                              
      if(tiket>0)
      {  
         if(OrderSelect(tiket,SELECT_BY_TICKET,MODE_TRADES)) OrderPrint(); 
      }
         else Print("order open error because of: ",GetLastError());        
}

void start()
{
   double cl = iClose(NULL,0,1);
   double op = iOpen(NULL,0,1);
   double hi = iHigh(NULL,0,1);
   double lo = iLow(NULL,0,1); 
      
   if (OrdersTotal()==0)
   {  
      if(cl==op && hi-lo>=5*Point)// filter 5 points
      {
         GlobalVariableSet(StringConcatenate(Symbol(),Period(),"up"),hi);
         GlobalVariableSet(StringConcatenate(Symbol(),Period(),"dn"),lo);
      }
   }
   
   if (OrdersTotal()==0) 
   {   
      if(Ask>=GlobalVariableGet(StringConcatenate(Symbol(),Period(),"up")) && GlobalVariableCheck(StringConcatenate(Symbol(),Period(),"up"))==true)
      {
         openorder(Symbol(),OP_BUY,Lot,Ask,Ask-SL*Point,Ask+TP*Point,"up level "+GlobalVariableGet(StringConcatenate(Symbol(),Period(),"up"))+"",111);
         GlobalVariablesDeleteAll(StringConcatenate(Symbol(),Period(),"up"));
      }
      if(Bid<=GlobalVariableGet(StringConcatenate(Symbol(),Period(),"dn"))&& GlobalVariableCheck(StringConcatenate(Symbol(),Period(),"dn"))==true)
      {
         openorder(Symbol(),OP_SELL,Lot,Bid,Bid+SL*Point,Bid-TP*Point,"dn level "+GlobalVariableGet(StringConcatenate(Symbol(),Period(),"dn"))+"",222); 
         GlobalVariablesDeleteAll(StringConcatenate(Symbol(),Period(),"dn"));
      }
    }
    
    if (OrdersTotal()==1)
    {
      for (int j=0;j<OrdersTotal();j++)
      OrderSelect(j,SELECT_BY_POS,MODE_TRADES);
      
      if(OrderSymbol()==Symbol() && OrderType()==OP_BUY && Bid<=GlobalVariableGet(StringConcatenate(Symbol(),Period(),"dn"))&& GlobalVariableCheck(StringConcatenate(Symbol(),Period(),"dn"))==true)
      {
         openorder(Symbol(),OP_SELL,Lot,Bid,Ask+SL*Point,Bid-TP*Point,"dn level "+GlobalVariableGet(StringConcatenate(Symbol(),Period(),"dn"))+"",222);
         GlobalVariablesDeleteAll(StringConcatenate(Symbol(),Period(),"dn"));
      }
      if(OrderSymbol()==Symbol()&& OrderType()==OP_SELL && Ask>=GlobalVariableGet(StringConcatenate(Symbol(),Period(),"up"))&& GlobalVariableCheck(StringConcatenate(Symbol(),Period(),"up"))==true)
      {
         openorder(Symbol(),OP_BUY,Lot,Ask,Bid-SL*Point,Ask+TP*Point,"up level"+GlobalVariableGet(StringConcatenate(Symbol(),Period(),"up"))+"",111);
         GlobalVariablesDeleteAll(StringConcatenate(Symbol(),Period(),"up"));
      }
    }  
}


